//+------------------------------------------------------------------------+
//|                       |
//|    / (c) www.usd.ucoz.ru / 24.01.2008     |    
//|                                                                        |
//|      /  /:         |
//| MF_Pivot AXEL 0-2254.mq4 / Copyright c YuraZ-VAF-Zhunko-Nestor         |
//| Pivot.mq4 / Copyright c 2004, MetaQuotes Software Corp.                |
//+------------------------------------------------------------------------+
#property copyright "http://usd.ucoz.ru"
#property link      "http://usd.ucoz.ru/forum"
#property indicator_chart_window 
#property indicator_buffers 1
//  .
#property indicator_color1 Yellow
//  .
#property indicator_style1 STYLE_DASH
//   .
#property indicator_width1 1
//-------------------------------------------------------------------------------------------------------------------------------------
extern double Time_Correct = 0;        // (0) (1)         GMT
int    Days_calculate = 1;             //   Days_calculate.
bool   Time_Summer = false;            // true -   / false -  .
//----   -------------------------------------------------------------------------------------------------------------
double Asia_period   = 12 ; //      .
double Europe_period =  9 ; //      .
double USA_period    =  6 ; //      .
//----         --------------------------------------------------------------------
string Start_ASIA          = "00:15" ;  //        GMT.
string Start_EUROPE = "06:15" ;  //        GMT.
string Start_USA    = "12:00" ;  //        GMT.
//---- -----------------------------------------------------------------------------------------------------------------------
int Text_Position  = 1   ;    // : 0 =  , 1 =  , 2 =  , 3 =  .
int XD             = 20 ;      //   X.
int YD             = 0   ;   //   Y.
bool TEXT_Visible = true  ;   // true -  ; false -   .
extern color PivotColor  = Magenta   ;    //   .
extern color RESColor    = DeepSkyBlue ;    //   .
extern color SUPColor    = Orange    ;    //   .
extern color TextColor   = LightCyan ;    //  .
//================================================================================================================================================
double nClose   = 0 ;
double nPivot   = 0 ; 
double nMaxHigh = 0 ; 
double nMinLow  = 0 ;

double nPivotEurope; // = nPivot; 
double nMaxHighE   ; // = nMaxHigh; 
double nMinLowE    ; // = nMinLow; 
double nCloseE     ; // = nClose; 

double PeriodHour_ ; // = Asia_period;
double hourMT4_    ; // = Asia___MT4_; 
double minuteMT4_  ; // = Asia___MT4_; 


//---------------------------------------------------------------
double    PBuffer[];
//---------------------------------------------------------------
static string ss1 = "Asia DJ Pivot"    ;
static string ss2 = "Europe DJ Pivot"  ;
static string ss3 = "Usa DJ Pivot"     ;
static string ss0 = "Downloads"        ;
extern bool pivots = true;
extern bool medium_pivots = false;
bool camarilla = false;

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double R1,R2,R3;
double S2.5,S1.5,S0.5,R0.5,R1.5,R2.5;
double S1,S2,S3;
double H4,H3,L4,L3;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];


//===============================================================
int init() 
 { 
  if ( TEXT_Visible == true )
   {
    ObjectCreate(ss0, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss0, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss0, OBJPROP_YDISTANCE, YD);
    ObjectSet(ss0, OBJPROP_CORNER, Text_Position);

//    ObjectCreate(ss1, OBJ_LABEL, 0, 0, 0);   
//    ObjectSet(ss1, OBJPROP_XDISTANCE, XD);
//    ObjectSet(ss1, OBJPROP_YDISTANCE, 15+YD);
//    ObjectSet(ss1, OBJPROP_CORNER, Text_Position);

    ObjectCreate(ss2, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss2, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss2, OBJPROP_YDISTANCE, 10+YD);
    ObjectSet(ss2, OBJPROP_CORNER, Text_Position);

//    ObjectCreate(ss3, OBJ_LABEL, 0, 0, 0);   
//    ObjectSet(ss3, OBJPROP_XDISTANCE, XD);
//    ObjectSet(ss3, OBJPROP_YDISTANCE, 35+YD);
//    ObjectSet(ss3, OBJPROP_CORNER, Text_Position);
   }
    SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(0,PBuffer);


//---- indicators
 R1=0; R2=0; R3=0;
 S2.5=0; S1.5=0; S0.5=0; R0.5=0; R1.5=0; R2.5=0;
 S1=0; S2=0; S3=0;
 H4=0; H3=0; L4=0; L3=0;
//----
  return(0); 
 }
//===============================================================
int deinit() 
{ 
  ObjectDelete(ss0);
  ObjectDelete(ss1);
  ObjectDelete(ss2);
  ObjectDelete(ss3);
//---- TODO: add your code here
ObjectDelete("R1 Label"); 
ObjectDelete("R1 Line");
ObjectDelete("R2 Label");
ObjectDelete("R2 Line");
ObjectDelete("R3 Label");
ObjectDelete("R3 Line");
ObjectDelete("S1 Label");
ObjectDelete("S1 Line");
ObjectDelete("S2 Label");
ObjectDelete("S2 Line");
ObjectDelete("S3 Label");
ObjectDelete("S3 Line");
ObjectDelete("P Label");
ObjectDelete("P Line");
ObjectDelete("H4 Label");
ObjectDelete("H4 Line");
ObjectDelete("H3 Label");
ObjectDelete("H3 Line");
ObjectDelete("L3 Label");
ObjectDelete("L3 Line");
ObjectDelete("L4 Label");
ObjectDelete("L4 Line");
ObjectDelete("R2.5 Label");
ObjectDelete("R2.5 Line");
ObjectDelete("R1.5 Label");
ObjectDelete("R1.5 Line");
ObjectDelete("R0.5 Label");
ObjectDelete("R0.5 Line");
ObjectDelete("S0.5 Label");
ObjectDelete("S0.5 Line");
ObjectDelete("S1.5 Label");
ObjectDelete("S1.5 Line");
ObjectDelete("S2.5 Label");
ObjectDelete("S2.5 Line");
//----

return(0); 
} 
//===============================================================
 void funPivot(int pDay, int pMonth, int pYear,  double PeriodHour, double hourMT4, double minuteMT4)
  { 
   datetime dTimeMT4end;
   datetime dTimeMT4begin;
   
   string sTimeMT4 = StringConcatenate(DoubleToStr( pYear, 0),".",DoubleToStr( pMonth , 0),".",DoubleToStr( pDay , 0)," ",
                     DoubleToStr( hourMT4, 0),":",DoubleToStr( minuteMT4, 0) ) ; 
                    
   dTimeMT4end = StrToTime(sTimeMT4); 
   dTimeMT4begin = dTimeMT4end - PeriodHour*3600+60  ;  
   
   if (TimeDayOfWeek (dTimeMT4begin) ==0)
   dTimeMT4begin = dTimeMT4begin - 172800;
   
   int      shiftend=iBarShift(NULL,PERIOD_M1,dTimeMT4end);
   int      shiftbegin=iBarShift(NULL,PERIOD_M1,dTimeMT4begin);
      
   nMinLow =iLow(NULL,PERIOD_M1,Lowest ( NULL, PERIOD_M1, MODE_LOW, shiftbegin-shiftend, shiftend));
   nMaxHigh= iHigh(NULL,PERIOD_M1,Highest( NULL, PERIOD_M1, MODE_HIGH, shiftbegin-shiftend, shiftend)); 
   nClose=iClose(NULL,PERIOD_M1,shiftend);
   nPivot = (nMaxHigh+nMinLow+nClose)/3;
   
   return; 
  } 
//================================================================
int start() 
 {
  int mDay;
  int mMonth ;
  int mYear  ;
  string mYearMonthDay;
//----------------------------------------------------------------
//  static double PeriodHour_ ; // = Asia_period;
//  static double hourMT4_    ; // = Asia___MT4_; 
//  static double minuteMT4_  ; // = Asia___MT4_; 

//  static double nPivotEurope; // = nPivot; 
//  static double nMaxHighE   ; // = nMaxHigh; 
//  static double nMinLowE    ; // = nMinLow; 
//  static double nCloseE     ; // = nClose; 

//  static double nPivotUSA   ; // = nPivot; 
//  static double nMaxHighU   ; // = nMaxHigh; 
//  static double nMinLowU    ; // = nMinLow; 
//  static double nCloseU     ; // = nClose; 

//  static double nPivotASIA  ; // = nPivot; 
//  static double nMaxHighA   ; // = nMaxHigh; 
//  static double nMinLowA    ; // = nMinLow; 
//  static double nCloseA     ; // = nClose; 
//-----------------------------------------------------------------
  datetime  mDatBegin;
  if (Bars != IndicatorCounted())
   {
    if (Days_calculate == 0 )
     {
      deinit();
      return(0);
     }
  else
     {
      mDatBegin = StrToTime(StringConcatenate(TimeToStr(CurTime(),TIME_DATE)," 00:00")) - ((Days_calculate-1) * 86400);
     }
//==================================================================
  for ( int i =0; mDatBegin < CurTime();  mDatBegin += 86400 )
   {
    mYear  = TimeYear( mDatBegin);
    mMonth = TimeMonth( mDatBegin);
    mDay   = TimeDay( mDatBegin);
    mYearMonthDay = StringConcatenate(DoubleToStr (mYear,0) , "." , DoubleToStr (mMonth, 0) , "." , DoubleToStr (mDay , 0));
//----------------------------------------------------------------------------------------------------------------------------------------------------------------
//    Start_ASIA=StringTrimRight(StringTrimLeft(Start_ASIA));
    Start_EUROPE=StringTrimRight(StringTrimLeft(Start_EUROPE));
//    Start_USA=StringTrimRight(StringTrimLeft(Start_USA));
    
    if (Time_Summer==true) int TWS =1;
    else TWS=0;
    
//    int  Asia_end_MT4_hour           = StrToDouble(StringSubstr(Start_ASIA, 0, 2)) + Time_Correct;
//    int  Asia_end_MT4_min            = StrToDouble(StringSubstr(Start_ASIA, 3, 2)) ;
                                    
    int  Europe_end_MT4_hour_pivot   = StrToDouble (StringSubstr(Start_EUROPE, 0, 2)) + Time_Correct;
//    int  Europe_end_MT4_hour_session = StrToDouble (StringSubstr(Start_EUROPE, 0, 2)) + Time_Correct - TWS;
    int  Europe_end_MT4_min          = StrToDouble (StringSubstr(Start_EUROPE, 3, 2)) ;
                                    
//    int  USA_end_MT4_hour_pivot      = StrToDouble (StringSubstr(Start_USA, 0, 2)) + Time_Correct - TWS;
//    int  USA_end_MT4_hour_session    = StrToDouble (StringSubstr(Start_USA, 0, 2)) + Time_Correct - TWS;
//    int  USA_end_MT4_min             = StrToDouble (StringSubstr(Start_USA, 3, 2)) ;
//----------------------------------------------------------------------------------------------------------------------------------------------------------------*/
//    PeriodHour_  = Asia_period;
//    hourMT4_     = Asia_end_MT4_hour;
//    minuteMT4_   = Asia_end_MT4_min;
//    funPivot( mDay, mMonth ,mYear ,PeriodHour_, hourMT4_, minuteMT4_);
//    nPivotASIA   = nPivot;
//    nMaxHighA    = nMaxHigh;
//    nMinLowA     = nMinLow;
//    nCloseA      = nClose;
//----------------------------------------------
    PeriodHour_  = Europe_period;
    hourMT4_     = Europe_end_MT4_hour_pivot;
    minuteMT4_   = Europe_end_MT4_min;
    funPivot(mDay, mMonth,mYear,PeriodHour_, hourMT4_, minuteMT4_);
    nPivotEurope = nPivot;
    nMaxHighE    = nMaxHigh;
    nMinLowE     = nMinLow;
    nCloseE      = nClose;
//----------------------------------------------
//    PeriodHour_  = USA_period;
//    hourMT4_     = USA_end_MT4_hour_pivot;
//    minuteMT4_   = USA_end_MT4_min;
//    funPivot(mDay, mMonth,mYear,PeriodHour_, hourMT4_, minuteMT4_);
//    nPivotUSA    = nPivot;
//    nMaxHighU    = nMaxHigh;
//    nMinLowU     = nMinLow;
//   nCloseU      = nClose;
//----------------------------------------------
//    string DC_ASIA   = StringConcatenate(mYearMonthDay , " " , Asia_end_MT4_hour, ":00");   
//    string DC_EUROPE = StringConcatenate(mYearMonthDay , " " , Europe_end_MT4_hour_session, ":00");   
//    string DC_USA    = StringConcatenate(mYearMonthDay , " " , USA_end_MT4_hour_session, ":00");   
   
//    int pPivotBARA = iBarShift (NULL,0,StrToTime (DC_ASIA)); 
//    int pPivotBARE = iBarShift (NULL,0,StrToTime (DC_EUROPE));  
//    int pPivotBARU = iBarShift (NULL,0,StrToTime (DC_USA));

      int j;

//      if ( nPivotASIA !=0 )
//         {
//          for (j =0  ; j < pPivotBARA; j++)
//            PBuffer[j] = nPivotASIA ;
//         }  
//      if ( nPivotEurope !=0)
//         {
//          for (j = 0 ; j < pPivotBARE; j++)
//            PBuffer[j] = nPivotEurope ;
//         }

//      if (nPivotUSA !=0 )
//         {
//          for (j = 0 ; j < pPivotBARU; j++)
//            PBuffer[j] = nPivotUSA ;
//         }
   }

   if (TEXT_Visible == true )
    {
//     string sPivotASIA    =  StringConcatenate("PivotAsia      =",DoubleToStr(nPivotASIA  ,Digits)," / High="+DoubleToStr(nMaxHighA,Digits)," Low=",DoubleToStr(nMinLowA,Digits)," Close=",DoubleToStr(nCloseA,Digits)) ; 
     string sPivotEUROPE  =  StringConcatenate("Axel-Pivot ="   ,DoubleToStr(nPivotEurope,Digits)," / High="+DoubleToStr(nMaxHighE,Digits)," Low=",DoubleToStr(nMinLowE,Digits)," Close=",DoubleToStr(nCloseE,Digits)) ;
//     string sPivotUSA     =  StringConcatenate("PivotUSA     ="  ,DoubleToStr(nPivotUSA   ,Digits)," / High="+DoubleToStr(nMaxHighU,Digits)," Low=",DoubleToStr(nMinLowU,Digits)," Close="+DoubleToStr(nCloseU,Digits)) ; 

     ObjectSetText(ss0, "Download from www.usd.ucoz.ru", 8, "Tahoma", TextColor); 
//     ObjectSetText(ss1, sPivotASIA   , 8, "Tahoma", TextColor); 
     ObjectSetText(ss2, sPivotEUROPE , 8, "Tahoma", TextColor); 
//     ObjectSetText(ss3, sPivotUSA    , 8, "Tahoma", TextColor); 

    }

usd();

 }
return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int usd()
  {
//---- TODO: add your code here
//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}
//---- Get new daily prices
//ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);


//yesterday_open = rates_d1[1][1];
yesterday_low = nMinLowE;
yesterday_high = nMaxHighE;
yesterday_close = nCloseE;
//---- Calculate Pivots



Q = (yesterday_high - yesterday_low);
P = (yesterday_high + yesterday_low + yesterday_close) / 3;
R1 = (2*P)-yesterday_low;
S1 = (2*P)-yesterday_high;
R2 = P+(yesterday_high - yesterday_low);
S2 = P-(yesterday_high - yesterday_low);

	H4 = (Q*0.55)+yesterday_close;
	H3 = (Q*0.27)+yesterday_close;
	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	R2.5 = (R2+R3)/2;
	R1.5 = (R1+R2)/2;
	R0.5 = (P+R1)/2;
	S0.5 = (P+S1)/2;
	S1.5 = (S1+S2)/2;
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);
	L3 = yesterday_close-(Q*0.27);	
	L4 = yesterday_close-(Q*0.55);	
	S2.5 = (S2+S3)/2;

// Comment("High= ",yesterday_high,"\nLow= ",yesterday_low,"\nClose= ",yesterday_close);
//---- Set line labels on chart window
//---- Pivot Lines
   if (pivots==true)
   {
      if(ObjectFind("R1 label") != 0)
      {
      ObjectCreate("R1 label", OBJ_TEXT, 0, Time[20], R1);
      ObjectSetText("R1 label", " R1", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R1 label", 0, Time[20], R1);
      }
      if(ObjectFind("R2 label") != 0)
      {
      ObjectCreate("R2 label", OBJ_TEXT, 0, Time[20], R2);
      ObjectSetText("R2 label", " R2", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R2 label", 0, Time[20], R2);
      }
      if(ObjectFind("R3 label") != 0)
      {
      ObjectCreate("R3 label", OBJ_TEXT, 0, Time[20], R3);
      ObjectSetText("R3 label", " R3", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R3 label", 0, Time[20], R3);
      }
      if(ObjectFind("P label") != 0)
      {
      ObjectCreate("P label", OBJ_TEXT, 0, Time[20], P);
      ObjectSetText("P label", "Pivot", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("P label", 0, Time[20], P);
      }
      if(ObjectFind("S1 label") != 0)
      {
      ObjectCreate("S1 label", OBJ_TEXT, 0, Time[20], S1);
      ObjectSetText("S1 label", "S1", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S1 label", 0, Time[20], S1);
      }
      if(ObjectFind("S2 label") != 0)
      {
      ObjectCreate("S2 label", OBJ_TEXT, 0, Time[20], S2);
      ObjectSetText("S2 label", "S2", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S2 label", 0, Time[20], S2);
      }
      if(ObjectFind("S3 label") != 0)
      {
      ObjectCreate("S3 label", OBJ_TEXT, 0, Time[20], S3);
      ObjectSetText("S3 label", "S3", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S3 label", 0, Time[20], S3);
      }
//---  Draw  Pivot lines on chart
      if(ObjectFind("S1 line") != 0)
      {
      ObjectCreate("S1 line", OBJ_HLINE, 0, Time[40], S1);
      ObjectSet("S1 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("S1 line", OBJPROP_COLOR, SUPColor);
      }
      else
      {
      ObjectMove("S1 line", 0, Time[40], S1);
      }
      if(ObjectFind("S2 line") != 0)
      {
      ObjectCreate("S2 line", OBJ_HLINE, 0, Time[40], S2);
      ObjectSet("S2 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("S2 line", OBJPROP_COLOR, SUPColor);
      }
      else
      {
      ObjectMove("S2 line", 0, Time[40], S2);
      }
      if(ObjectFind("S3 line") != 0)
      {
      ObjectCreate("S3 line", OBJ_HLINE, 0, Time[40], S3);
      ObjectSet("S3 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("S3 line", OBJPROP_COLOR, SUPColor);
      }
      else
      {
      ObjectMove("S3 line", 0, Time[40], S3);
      }
      if(ObjectFind("P line") != 0)
      {
      ObjectCreate("P line", OBJ_HLINE, 0, Time[40], P);
      ObjectSet("P line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("P line", OBJPROP_COLOR, PivotColor);
      }
      else
      {
      ObjectMove("P line", 0, Time[40], P);
      }
      if(ObjectFind("R1 line") != 0)
      {
      ObjectCreate("R1 line", OBJ_HLINE, 0, Time[40], R1);
      ObjectSet("R1 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("R1 line", OBJPROP_COLOR, RESColor);
      }
      else
      {
      ObjectMove("R1 line", 0, Time[40], R1);
      }
      if(ObjectFind("R2 line") != 0)
      {
      ObjectCreate("R2 line", OBJ_HLINE, 0, Time[40], R2);
      ObjectSet("R2 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("R2 line", OBJPROP_COLOR, RESColor);
      }
      else
      {
      ObjectMove("R2 line", 0, Time[40], R2);
      }
      if(ObjectFind("R3 line") != 0)
      {
      ObjectCreate("R3 line", OBJ_HLINE, 0, Time[40], R3);
      ObjectSet("R3 line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("R3 line", OBJPROP_COLOR, RESColor);
      }
      else
      {
      ObjectMove("R3 line", 0, Time[40], R3);
      }
   }
//---- End of Pivot Line Draw 
//----- Camarilla Lines
   if (camarilla==true)
   {
      if(ObjectFind("H4 label") != 0)
      {
      ObjectCreate("H4 label", OBJ_TEXT, 0, Time[20], H4);
      ObjectSetText("H4 label", " H4", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H4 label", 0, Time[20], H4);
      }
      if(ObjectFind("H3 label") != 0)
      {
      ObjectCreate("H3 label", OBJ_TEXT, 0, Time[20], H3);
      ObjectSetText("H3 label", " H3", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H3 label", 0, Time[20], H3);
      }
      if(ObjectFind("L3 label") != 0)
      {
      ObjectCreate("L3 label", OBJ_TEXT, 0, Time[20], L3);
      ObjectSetText("L3 label", " L3", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L3 label", 0, Time[20], L3);
      }
      if(ObjectFind("L4 label") != 0)
      {
      ObjectCreate("L4 label", OBJ_TEXT, 0, Time[20], L4);
      ObjectSetText("L4 label", " L4", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L4 label", 0, Time[20], L4);
      }
//---- Draw Camarilla lines on Chart
      if(ObjectFind("H4 line") != 0)
      {
      ObjectCreate("H4 line", OBJ_HLINE, 0, Time[40], H4);
      ObjectSet("H4 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("H4 line", OBJPROP_COLOR, RosyBrown);
      }
      else
      {
      ObjectMove("H4 line", 0, Time[40], H4);
      }
      if(ObjectFind("H3 line") != 0)
      {
      ObjectCreate("H3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("H3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("H3 line", OBJPROP_COLOR, RosyBrown);
      }
      else
      {
      ObjectMove("H3 line", 0, Time[40], H3);
      }
      if(ObjectFind("L3 line") != 0)
      {
      ObjectCreate("L3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("L3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("L3 line", OBJPROP_COLOR, RosyBrown);
      }
      else
      {
      ObjectMove("L3 line", 0, Time[40], L3);
      }
      if(ObjectFind("L4 line") != 0)
      {
      ObjectCreate("L4 line", OBJ_HLINE, 0, Time[40], L4);
      ObjectSet("L4 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("L4 line", OBJPROP_COLOR, RosyBrown);
      }
      else
      {
      ObjectMove("L4 line", 0, Time[40], L4);
      }
   }
//-------End of Draw Camarilla Lines
//------ Midpoints Pivots 
   if (medium_pivots==true)
   {
      if(ObjectFind("R2.5 label") != 0)
      {
      ObjectCreate("R2.5 label", OBJ_TEXT, 0, Time[20], R2.5);
      ObjectSetText("R2.5 label", " R2.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R2.5 label", 0, Time[20], R2.5);
      }
      if(ObjectFind("R1.5 label") != 0)
      {
      ObjectCreate("R1.5 label", OBJ_TEXT, 0, Time[20], R1.5);
      ObjectSetText("R1.5 label", " R1.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R1.5 label", 0, Time[20], R1.5);
      }
      if(ObjectFind("R0.5 label") != 0)
      {
      ObjectCreate("R0.5 label", OBJ_TEXT, 0, Time[20], R0.5);
      ObjectSetText("R0.5 label", " R0.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("R0.5 label", 0, Time[20], R0.5);
      }
      if(ObjectFind("S0.5 label") != 0)
      {
      ObjectCreate("S0.5 label", OBJ_TEXT, 0, Time[20], S0.5);
      ObjectSetText("S0.5 label", " S0.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S0.5 label", 0, Time[20], S0.5);
      }
      if(ObjectFind("S1.5 label") != 0)
      {
      ObjectCreate("S1.5 label", OBJ_TEXT, 0, Time[20], S1.5);
      ObjectSetText("S1.5 label", " S1.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S1.5 label", 0, Time[20], S1.5);
      }
      if(ObjectFind("S2.5 label") != 0)
      {
      ObjectCreate("S2.5 label", OBJ_TEXT, 0, Time[20], S2.5);
      ObjectSetText("S2.5 label", " S2.5", 8, "Arial", TextColor);
      }
      else
      {
      ObjectMove("S2.5 label", 0, Time[20], S2.5);
      }
//---- Draw Midpoint Pivots on Chart
      if(ObjectFind("R2.5 line") != 0)
      {
      ObjectCreate("R2.5 line", OBJ_HLINE, 0, Time[40], R2.5);
      ObjectSet("R2.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("R2.5 line", OBJPROP_COLOR, DodgerBlue);
      }
      else
      {
      ObjectMove("R2.5 line", 0, Time[40], R2.5);
      }
      if(ObjectFind("R1.5 line") != 0)
      {
      ObjectCreate("R1.5 line", OBJ_HLINE, 0, Time[40], R1.5);
      ObjectSet("R1.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("R1.5 line", OBJPROP_COLOR, DodgerBlue);
      }
      else
      {
      ObjectMove("R1.5 line", 0, Time[40], R1.5);
      }
      if(ObjectFind("R0.5 line") != 0)
      {
      ObjectCreate("R0.5 line", OBJ_HLINE, 0, Time[40], R0.5);
      ObjectSet("R0.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("R0.5 line", OBJPROP_COLOR, DodgerBlue);
      }
      else
      {
      ObjectMove("R0.5 line", 0, Time[40], R0.5);
      }
      if(ObjectFind("S0.5 line") != 0)
      {
      ObjectCreate("S0.5 line", OBJ_HLINE, 0, Time[40], S0.5);
      ObjectSet("S0.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("S0.5 line", OBJPROP_COLOR, Goldenrod);
      }
      else
      {
      ObjectMove("S0.5 line", 0, Time[40], S0.5);
      }
      if(ObjectFind("S1.5 line") != 0)
      {
      ObjectCreate("S1.5 line", OBJ_HLINE, 0, Time[40], S1.5);
      ObjectSet("S1.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("S1.5 line", OBJPROP_COLOR, Goldenrod);
      }
      else
      {
      ObjectMove("S1.5 line", 0, Time[40], S1.5);
      }
      if(ObjectFind("S2.5 line") != 0)
      {
      ObjectCreate("S2.5 line", OBJ_HLINE, 0, Time[40], S2.5);
      ObjectSet("S2.5 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("S2.5 line", OBJPROP_COLOR, Goldenrod);
      }
      else
      {
      ObjectMove("S2.5 line", 0, Time[40], S2.5);
      }
   }
//----End of Midpoint Pivots Draw
//---- End Of Program
   return(0);
  }

